talk(n, _, _):-!.
talk(y, Call, n):- lwrite([nl,'   Trying: ', nl]),
        display_call(Call).
talk(y, _, Answer):-
	lwrite([nl,'   Failed!     Want to see why? (y/n) ']),
	read(Answer), Answer == y, !.


display_call( greater( spo(Q), S, T ) ):-
	lwrite(['     ', S, '  >  ', T, nl, 
	'        with spo and quasi-order Q:', nl]),
	display_q(Q,5),!.
display_call( grequal( spo(Q), S, T ) ):-
	lwrite(['     ', S, '  >=  ', T, nl, 
	'        with spo and quasi-order Q:', nl]),
	display_q(Q,5),!.
display_call( equal( spo(Q), S, T ) ):-
	lwrite(['     ', S, '  =  ', T, nl, 
	'        with spo and quasi-order Q:', nl]),
	display_q(Q,5),!.


display_call( greater_than_list(Order, S, L) ):-
	lwrite(['     ', S, '  >  ', L, nl, 
	'        with order:', nl, '     ',Order,nl]),!.
display_call( greater_multiset(Order, L1, L2) ):-
	lwrite(['     ', L1, '  >>  ', L2, nl, 
	'        with order:', nl, '     ',Order,nl]),!.



display_call( greater( int(Int,Order), S, T ) ):-
	lwrite(['     ', int(S), '  >  ', int(T), nl, '        with order: ',nl,
	'     ', Order, nl, '        and interpretation: ',nl]),
	display_interpretation(Int),!.
display_call( grequal( int(Int,Order), S, T ) ):-
	lwrite(['     ', int(S), '  >=  ', int(T), nl, '        with order: ',nl,
	'     ', Order, nl, '        and interpretation: ',nl]),
	display_interpretation(Int),!.
display_call( equal( int(Int,Order), S, T ) ):-
	lwrite(['     ', int(S), '  =  ', int(T), nl, '        with order: ',nl,
	'     ', Order, nl, '        and interpretation: ',nl]),
	display_interpretation(Int),!.


display_call( greater( q(Q), S, T ) ):-
	lwrite(['     ', S, '  >  ', T, nl, '        with quasi-order Q: ',nl]),
	display_q(Q,5),!.
display_call( grequal( q(Q), S, T ) ):-
	lwrite(['     ', S, '  >=  ', T, nl, '        with quasi-order Q: ',nl]),
	display_q(Q,5),!.
display_call( equal( q(Q), S, T ) ):-
	lwrite(['     ', S, '  =  ', T, nl, '        with quasi-order Q: ',nl]),
	display_q(Q,5),!.

display_call( greater( rpo(P,L), S, T ) ):-
	lwrite(['     ', S, '  >  ', T, nl, '        with:', nl, 
	'        ', rpo(P,L), nl]),!.
display_call( grequal( rpo(P,L), S, T ) ):-
	lwrite(['     ', S, '  >=  ', T, nl, '        with:', nl,
	'        ',  rpo(P,L), nl]),!.
display_call( equal( rpo(_,L), S, T ) ):-
	lwrite(['     ', S, '  =  ', T, nl, '        with:', nl, 
	'        ', rpo(_,L), nl]),!.

display_call( Call ):- lwrite([Call,nl]),!.



talk_no_answer(n, _ ):-!.
talk_no_answer(y, Call ):- lwrite([nl,'   Trying: ', nl]),
	display_call(Call),!.
talk_no_answer(y, _ ):- lwrite([nl,'   Obviously failed! ',nl]), !.


talk_ok( n ):-!.
talk_ok( y ):-
	lwrite([nl,'   Succeeded.',nl]),!.


% MSPO

greater( mspo(Int,Q), S, T, Spy ):-
	talk( Spy, grequal( Int, S, T), Spy1 ),
	grequal( Int, S, T, Spy1 ),
	talk_ok( Spy ), !,
	talk( Spy, greater( spo(Q), S, T), Spy2 ),
	greater( spo(Q), S, T, Spy2), !.


% INT

greater( int(Int,Order), S, T, Spy):-
	interprete_term(S, IS, Int),
	interprete_term(T, IT, Int),
	talk( Spy, greater(Order, IS, IT), Spy1 ),
	greater(Order, IS, IT, Spy1), !.

grequal( int(Int,Order), S, T, Spy):-
	interprete_term(S, IS, Int),
	interprete_term(T, IT, Int),
	talk( Spy, grequal(Order, IS, IT), Spy1 ),
	grequal(Order, IS, IT, Spy1), !.

equal( int(Int,Order), S, T, Spy):-
	interprete_term(S, IS, Int),
	interprete_term(T, IT, Int),
	talk( Spy, equal(Order, IS, IT), Spy1 ),
	equal(Order, IS, IT, Spy1), !.



% SPO

greater( spo(_), S, _, _ ):- var(S), !, fail.
greater( spo(Q), S, T, Spy ):-
        nonvar(T),
	talk( Spy, greater(q(Q), S, T), Spy1 ),
        greater( q(Q), S, T, Spy1 ), !,
	talk_ok( Spy ), !,
	T =.. [_|Args2],
	talk( Spy, greater_than_list(spo(Q), S, Args2), Spy2 ),
        greater_than_list( spo(Q), S, Args2, Spy2), !.
greater( spo(Q), S, T, Spy ):-
	nonvar(T),
	talk( Spy, grequal(q(Q), S, T), Spy1 ),
        grequal( q(Q), S, T, Spy1), !,
	talk_ok( Spy ), !,
	S =.. [_|Args1],
	T =.. [_|Args2],
	talk( Spy, greater_multiset(spo(Q), Args1, Args2), Spy2 ),
        greater_multiset( spo(Q), Args1, Args2, Spy2), !.
greater( spo(Q), S, T, Spy ):-
        S =.. [_|Args1],
        member22(S1, Args1),
	talk( Spy, grequal( spo(Q), S1, T), Spy1 ),
        grequal( spo(Q), S1, T, Spy1 ), !.


grequal( spo(Q), S, T, Spy ):- equal( spo(Q), S, T, Spy ),!.
grequal( spo(Q), S, T, Spy ):- greater( spo(Q), S, T, Spy ),!.


equal( spo(_), S, T, _ ):- S == T, !.
equal( spo(Q), S, T, Spy ):-
        nonvar(S),
        nonvar(T),
	talk( Spy, equal(q(Q), S, T), Spy1 ),
        equal( q(Q), S, T, Spy1),
	talk_ok( Spy ),!,
        S =.. [_|Args1],
        T =.. [_|Args2],
	talk( Spy, equal_multiset(q(Q), S, T), Spy2 ),
        equal_multiset( spo(Q), Args1, Args2, Spy2 ), !.


% Q

greater( q(int(Int,Base)), S, T, Spy):-
	talk( Spy, greater( int(Int,Base), S, T), Spy1 ),
	greater( int(Int,Base), S, T, Spy1 ),!.
greater( q(pre(P)), S, T, Spy):-
	nonvar(S),
	nonvar(T),
	functor(S,F,_),
	functor(T,G,_),
	talk_no_answer( Spy, greater_precedence(F,G,P) ),
	member212( F>G, P ),!.
greater( q(ren(R,Q)), S, T, Spy):-
	rename( S, R, S1 ),
	rename( T, R, T1 ), !,
	talk( Spy, greater( q(Q), S1, T1), Spy1 ),
	greater( q(Q), S1, T1, Spy1 ),!.
greater( q(L), S, T, Spy):-
	L =.. [lex|Qs],
	greater( lex(Qs), S, T, Spy ),!.


greater( lex([Q|_]), S, T, Spy ):-
	talk( Spy, greater( q(Q), S, T), Spy1 ),
	greater( q(Q), S, T, Spy1 ),!.
greater( lex([Q|Qs]), S, T, Spy ):-
	talk( Spy, grequal( q(Q), S, T), Spy1 ),
	grequal( q(Q), S, T, Spy1 ), !,
	talk_ok( Spy ),!,
	greater( lex(Qs), S, T, Spy ),!.


grequal( q(int(Int,Base)), S, T, Spy):-
	talk( Spy, grequal( int(Int,Base), S, T), Spy1 ),
	grequal( int(Int,Base), S, T, Spy1 ),!.
grequal( q(pre(P)), S, T, Spy):-
	functor(S,F,_),
	functor(T,G,_),
	talk_no_answer( Spy, grequal_precedence(F,G,P) ),
	( F==G; member212( F>G, P); member212( F=G, P ); member212( G=F, P ) ),!.
grequal( q(ren(R,Q)), S, T, Spy):-
	rename( S, R, S1 ),
	rename( T, R, T1 ), !,
	talk( Spy, grequal( q(Q), S1, T1), Spy1 ),
	grequal( q(Q), S1, T1, Spy1 ),!.
grequal( q(L), S, T, Spy):-
	L =.. [lex|Qs],
	grequal( lex(Qs), S, T, Spy ),!.


grequal( lex([]), _, _, _ ):- !.
grequal( lex([Q|_]), S, T, Spy ):-
	talk( Spy, greater( q(Q), S, T), Spy1 ),
	greater( q(Q), S, T, Spy1 ),!.
grequal( lex([Q|Qs]), S, T, Spy ):-
	talk( Spy, grequal( q(Q), S, T), Spy1 ),
	grequal( q(Q), S, T, Spy1 ), !,
	talk_ok( Spy ),!,
	grequal( lex(Qs), S, T, Spy ),!.


equal( q(Q), S, T, Spy):- 
	talk( Spy, grequal( q(Q), S, T), Spy1 ),
	grequal( q(Q), S, T, Spy1),
	talk_ok( Spy ),!,
	talk( Spy, grequal( q(Q), T, S), Spy2 ),
	grequal( q(Q), T, S, Spy2),!.



rename( T, R, T1 ):-
	nonvar(T),
	T =.. [F|Args],
	member22( ren(F)=G, R ),!,
	T1 =.. [G|Args],!.
rename( T, _, T ):-!.


% RPO

greater( rpo(_,_), S, _, _):- var(S), !, fail.
greater( rpo(Prec,LexStat), S, T, Spy):-
	nonvar(T),
        S =.. [F|Args1],
        T =.. [F|Args2],			% can we use equal_op????
	\+ member212(F, LexStat), !,
	talk( Spy, greater_multiset( rpo(Prec,LexStat), Args1, Args2), Spy1 ),
	greater_multiset( rpo(Prec,LexStat), Args1, Args2, Spy1).
greater( rpo(Prec,LexStat), S, T, Spy):-
	nonvar(T),
        S =.. [F|Args1],
        T =.. [F|Args2],
	member212(F, LexStat),
	talk_no_answer( Spy, greater_lexicographic( rpo(Prec,LexStat), S, Args1, Args2)),
        greater_lexicographic( rpo(Prec,LexStat), S, Args1, Args2).
greater( rpo(Prec,LexStat), S, T, Spy):-
	nonvar(T),
        S =.. [F|_],
        T =.. [G|Args2],
	F \== G,
        member212(F>G,Prec), !,
	talk( Spy, greater_than_list( rpo(Prec,LexStat), S, Args2), Spy1 ),
        greater_than_list( rpo(Prec,LexStat), S, Args2, Spy1).
greater( rpo(Prec,LexStat), S, T, Spy):-
        S =.. [_|Args1],
        member22(S1, Args1),
	talk( Spy, grequal( rpo(Prec,LexStat), S1, T), Spy1 ),
        grequal( rpo(Prec,LexStat), S1, T, Spy1), !.

equal( rpo(_,LexStat), S, T, Spy):- 
	talk_no_answer( Spy, equal_up2_perms_of_mulops(LexStat, S, T) ),
	equal_up2_perms_of_mulops(LexStat, S, T).

grequal( rpo(Prec,LexStat), S, T, Spy):- equal( rpo(Prec,LexStat), S, T, Spy),!.
grequal( rpo(Prec,LexStat), S, T, Spy):- greater( rpo(Prec,LexStat), S, T, Spy),!.


%------------------------------------------------------------------------------
% interprete_term(T, IT, Int)
%------------------------------------------------------------------------------

interprete_term(T, IT, Int):-
	nonvar(T),
	functor(T,F,_),
	member22([L,R],Int),
	L =.. [F|ArgsL],
	var(R), !,
	nth_variable( ArgsL, R, N ),
	arg( N, T, Arg ),
	interprete_term( Arg, IT, Int), !.
interprete_term(T, IT, Int):-
	nonvar(T),
	functor(T,F,_),
	member22([L,R],Int),
	L =.. [F|ArgsL],!,
	R  =.. [G|ArgsR],
	get_args_list( ArgsL, ArgsR, T, ArgsT1 ),
	interprete_term_list( ArgsT1, Args1, Int),
	IT =.. [G|Args1],!.
interprete_term(T, IT, Int):-
	nonvar(T),
	T  =.. [F|Args],
	interprete_term_list( Args, Args1, Int),
	IT =.. [F|Args1],!.
interprete_term( T, T, _ ):-!.


nth_variable( [X1|_], X, 1 ):- X == X1,!.
nth_variable( [_|L],  X, N ):- nth_variable(L,X,N1), N is N1 + 1,!.	


get_args_list( _, [], _, [] ):-!.
get_args_list( ArgsL, [X|ArgsR], T, [Tn|ArgsT1] ):-
	nth_variable( ArgsL, X, N ), !,
	arg( N, T, Tn ),
	get_args_list( ArgsL, ArgsR, T, ArgsT1 ), !.

interprete_term_list( [], [], _ ):-!.
interprete_term_list( [T|R], [IT|IR], Int):-
	interprete_term( T, IT, Int ),
	interprete_term_list( R, IR, Int),!.

%------------------------------------------------------------------------------
% equal_up2_perms_of_mulops(LexStat, S, T)
%------------------------------------------------------------------------------

equal_up2_perms_of_mulops(_, S, T):- var(S), !, S == T.
equal_up2_perms_of_mulops(_, S, T):- atomic(S), !, S == T.
equal_up2_perms_of_mulops(LexStat, S, T):-
	nonvar(T),
        S =.. [F|RS],
        T =.. [F|RT],
	member212(F, LexStat),!,
	equal_sequence_up2(LexStat, RS, RT).
equal_up2_perms_of_mulops(LexStat, S, T):-
	nonvar(T),
        S =.. [F|RS],
        T =.. [F|RT],
	equal_multiset_up2(LexStat, RS, RT).

equal_sequence_up2(_, [], []).
equal_sequence_up2(LexStat, [S1|R1], [S2|R2]):-
	equal_up2_perms_of_mulops(LexStat, S1, S2),
	equal_sequence_up2(LexStat, R1, R2), !.

equal_multiset_up2(_, [], []).
equal_multiset_up2(LexStat, [S|R], L):-
	delete32(T, L, L1),
	equal_up2_perms_of_mulops(LexStat, S, T),
	equal_multiset_up2(LexStat, R, L1), !.


%------------------------------------------------------------------------------
% greater_lexicographic(Order, S, Args1, Args2)
% greater_than_list(Order, S, L)
% greater_multiset(Order, Args1, Args2)
%------------------------------------------------------------------------------

greater_lexicographic(Order, S, [S1|_], [T1|R2]):-
        greater(Order, S1, T1), !,
        greater_than_list(Order, S, R2).
greater_lexicographic(Order, S, [S1|R1], [T1|R2]):-
	equal(Order, S1, T1),
        greater_lexicographic(Order, S, R1, R2), !.

greater_than_list(_, _, [], _):- !.
greater_than_list(Order, S, [T|R], Spy):-
	talk( Spy, greater( Order, S, T), Spy1 ),
        greater(Order, S, T, Spy1),
	talk_ok( Spy ), !,
	talk( Spy, greater_than_list( Order, S, R), Spy2 ),
        greater_than_list(Order, S, R, Spy2),!.

greater_multiset(Order, M1, M2, Spy):-
        delete_equals(Order, M1, M2, N1, N2, Spy),
	talk( Spy, gr_mult( Order, N1, N2), Spy1 ),
        gr_mult(Order, N1, N2, Spy1).


equal_multiset(Order, M1, M2, Spy ):-
        delete_equals(Order, M1, M2, [], [], Spy), !.


delete_equals(_, [], A, [], A, _ ):- !.
delete_equals(Order, [S|R], A, C1, C2, Spy):-
        delete32(T, A, A1),
	talk( Spy, equal( Order, S, T), Spy1 ),
        equal(Order, S, T, Spy1 ), !,
        talk_ok( Spy ),!,
	talk( Spy, delete_equals( Order, R, A1, C1, C2), Spy2 ),
        delete_equals(Order, R, A1, C1, C2, Spy2 ), !.
delete_equals(Order, [S|R], A, [S|R1], A1, Spy ):-
        delete_equals(Order, R, A, R1, A1, Spy ), !.


gr_mult(_, [], _, _ ):- !, fail.
gr_mult(_, [_|_], [], _ ):- !.
gr_mult(Order, N1, [T2|R2], Spy):-
	member22(T1, N1),
	talk( Spy, greater( Order, T1, T2), Spy1 ),
        greater(Order, T1, T2, Spy1),
	talk_ok(Spy),!,
	talk( Spy, gr_mult( Order, N1, R2), Spy2 ),
        gr_mult(Order, N1, R2, Spy2).


% eof -------------------------------------------------------------------------

