
order:- seen,
        write('File: '), read(F), see(F),
	read_ordering(Ord),
        read_rules(Rules),
        seen, !,
	display_ordering(Ord),
	display_rules(Rules),
	terminating( Ord, Rules ), !.


read_rules(Rules):-
	read(R),
	read_rules(R,Rules).
read_rules('end_of_file', []):-!.
read_rules(R, [R|Rules]):-
	read(R1),
        read_rules(R1, Rules), !.

display_rules(R):-
	nl, nl, write('Set of Rules:'), nl,
	disp_rules(R).

disp_rules([]):- nl, !.
disp_rules([L>R|Rest]):-
	lwrite(['    ', L, ' -> ', R, nl]),
	disp_rules(Rest). 

terminating( _, [] ):-!.
terminating( Ord, [L>R|Rules] ):-
	greater( Ord, L, R, n ),
	terminating( Ord, Rules ),!.
terminating( Ord, [L>R|Rules] ):-
	lwrite(['    Cannot orient:', nl, '        ', L, ' -> ', R, nl]),
	lwrite(['    Want to see why? (y/n) ']),
	read(Answer), Answer == y, !,
	greater( Ord, L, R, y ),
	terminating( Ord, Rules ),!.
terminating( Ord, [_|Rules] ):-
	terminating( Ord, Rules ),!.

% eof--------------------------------------------------------------------------

